if string.lower(RequiredScript) == "lib/managers/menumanager" then

	function MenuManager:show_respec_dialog(params)
		managers.system_menu:show({
			title = utf8.to_upper(managers.localization:text("menu_character_skills_retrain_dialog_title_free")), -- replace title
			text = utf8.to_upper(managers.localization:text("menu_character_skills_retrain_dialog_text_free")), -- replace text
			button_list = {
				{
					text = utf8.to_upper(managers.localization:text("dialog_yes")),
					--class = RaidGUIControlButtonShortPrimaryGold, -- commented out, to use default instead of golden one
					callback_func = params.callback_yes -- here callback_yes, there yes_callback. ¯\(°_o)/¯
				},
				{
					text = utf8.to_upper(managers.localization:text("dialog_no")),
					class = RaidGUIControlButtonShortSecondary,
					cancel_button = true
				}
			}
		})
	end

	function MenuManager:show_skill_selection_confirm_dialog(params)
		managers.system_menu:show({
			title = utf8.to_upper(managers.localization:text("menu_character_skills_selection_confirmation_title")),
			text = utf8.to_upper(managers.localization:text("menu_character_skills_selection_confirmation_text_free")), -- replace text
			button_list = {
				{
					text = utf8.to_upper(managers.localization:text("dialog_yes")),
					callback_func = params.yes_callback -- here yes_callback, there callback_yes. ¯\(°_o)/¯
				},
				{
					text = utf8.to_upper(managers.localization:text("dialog_no")),
					class = RaidGUIControlButtonShortSecondary,
					cancel_button = true
				}
			}
		})
	end

elseif string.lower(RequiredScript) == "lib/managers/goldeconomymanager" then

	function GoldEconomyManager:respec_cost()
		return 0 -- always for free
	end

	function GoldEconomyManager:respec()
		-- do nothing
	end

elseif string.lower(RequiredScript) == "lib/managers/menu/raid_menu/experiencegui" then

	local _calculate_respec_visibility_original = ExperienceGui._calculate_respec_visibility
	local _layout_buttons_original = ExperienceGui._layout_buttons

	function ExperienceGui:_calculate_respec_visibility(...)
		_calculate_respec_visibility_original(self, ...)
		-- hide costs
		self._cost_icon:hide()
		self._cost_label:hide()
	end

	function ExperienceGui:_layout_buttons(...)
		local short_primary_gold_button_original = self._root_panel.short_primary_gold_button -- store original function
		self._root_panel.short_primary_gold_button = self._root_panel.short_primary_button -- replace function temporary
		_layout_buttons_original(self, ...)
		self._root_panel.short_primary_gold_button = short_primary_gold_button_original -- revert to original function
	end

elseif string.lower(RequiredScript) == "lib/managers/menu/raid_menu/controls/custom/raidguicontrolrespec" then

	local _create_respec_description_original = RaidGUIControlRespec._create_respec_description

	function RaidGUIControlRespec:_create_respec_description(...)
		_create_respec_description_original(self, ...)
		-- replace description
		self._description:set_text(managers.localization:text("menu_character_skills_retrain_desc_free"))
	end

end